# mypy-boto3-marketplace-entitlement

[![PyPI - mypy-boto3-marketplace-entitlement](https://img.shields.io/pypi/v/mypy-boto3-marketplace-entitlement.svg?color=blue)](https://pypi.org/project/mypy-boto3-marketplace-entitlement)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-marketplace-entitlement.svg?color=blue)](https://pypi.org/project/mypy-boto3-marketplace-entitlement)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-marketplace-entitlement?color=blue)](https://pypistats.org/packages/mypy-boto3-marketplace-entitlement)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.MarketplaceEntitlementService 1.17.57](https://boto3.amazonaws.com/v1/documentation/api/1.17.57/reference/services/marketplace-entitlement.html#MarketplaceEntitlementService) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 4.6.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-marketplace-entitlement](#mypy-boto3-marketplace-entitlement)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `MarketplaceEntitlementService` service.

```bash
python -m pip install boto3-stubs[marketplace-entitlement]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[marketplace-entitlement]` in your environment: `python -m pip install 'boto3-stubs[marketplace-entitlement]'`

Both type checking and auto-complete should work for `MarketplaceEntitlementService` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[marketplace-entitlement]` in your environment: `python -m pip install 'boto3-stubs[marketplace-entitlement]'`

Both type checking and auto-complete should work for `MarketplaceEntitlementService` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[marketplace-entitlement]` in your environment: `python -m pip install 'boto3-stubs[marketplace-entitlement]'`
- Run `mypy` as usual

Type checking should work for `MarketplaceEntitlementService` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[marketplace-entitlement]` in your environment: `python -m pip install 'boto3-stubs[marketplace-entitlement]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `MarketplaceEntitlementService` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`MarketplaceEntitlementServiceClient` provides annotations for `boto3.client("marketplace-entitlement")`.

```python
import boto3

from mypy_boto3_marketplace_entitlement import MarketplaceEntitlementServiceClient

client: MarketplaceEntitlementServiceClient = boto3.client("marketplace-entitlement")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: MarketplaceEntitlementServiceClient = session.client("marketplace-entitlement")
```

### Paginators annotations

`mypy_boto3_marketplace_entitlement.paginator` module contains type annotations for all paginators.

```python
from mypy_boto3_marketplace_entitlement import MarketplaceEntitlementServiceClient
from mypy_boto3_marketplace_entitlement.paginator import (
    GetEntitlementsPaginator,
)

client: MarketplaceEntitlementServiceClient = boto3.client("marketplace-entitlement")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
get_entitlements_paginator: GetEntitlementsPaginator = client.get_paginator("get_entitlements")
```







### Typed dictionations

`mypy_boto3_marketplace_entitlement.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_marketplace_entitlement.type_defs import (
    EntitlementTypeDef,
    EntitlementValueTypeDef,
    GetEntitlementsResultTypeDef,
    PaginatorConfigTypeDef,
)

def get_structure() -> EntitlementTypeDef:
    return {
      ...
    }
```
